.486
.model flat, stdcall  ;32 bit memory model
option casemap :none  ;case sensitive

include ReadRegKey.inc



.data
    lpszSubKey		DB  "SYSTEM\CurrentControlSet\Control\ComputerName\ComputerName",0
    lpszValueName   DB  "ComputerName",0
    szMBCapt		DB	"Registry Error",0
    szNoFindKey		DB	"Key not present.",0
    szNoFindVal		DB	"Value not present.",0

.data?
    lpbData		DD 256 Dup (?)
    lpcbData    DD  ?
    hKey        DD  ?
    lpdwType    DD  ?
	VBufLen		dd	?
	Buffer		db 1024 dup(?)
.code

start:
	invoke	GetModuleHandle,NULL
	mov	hInstance,eax
	invoke	InitCommonControls
	invoke	DialogBoxParam,hInstance,IDD_MAIN,NULL,addr DlgProc,NULL
	invoke	ExitProcess,0

;########################################################################

DlgProc	proc	hWin:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
	mov	eax,uMsg
	.if	eax==WM_INITDIALOG
		;initialization here
	    invoke RegOpenKeyEx,HKEY_LOCAL_MACHINE,addr lpszSubKey,0,KEY_QUERY_VALUE,addr hKey
	    cmp eax,ERROR_SUCCESS
	    jne NoKeyFound
	    mov VBufLen,sizeof Buffer
	    invoke RegQueryValueEx,hKey,addr lpszValueName,0,addr lpdwType,addr lpbData,addr VBufLen
	    cmp eax,ERROR_SUCCESS
	    jne NoValFound
	    INVOKE SendDlgItemMessage,hWin,103,WM_SETTEXT, 0, OFFSET lpbData+NULL
	    Invoke RegCloseKey,hKey
	    jmp EndKeyRead
	NoKeyFound:
	    INVOKE MessageBox,NULL,addr szNoFindKey,addr szMBCapt,MB_OK
	    jmp EndKeyRead
	NoValFound:
	    INVOKE MessageBox,NULL,addr szNoFindVal,addr szMBCapt,MB_OK
	    Invoke RegCloseKey,hKey
	EndKeyRead:
	.elseif	eax==WM_COMMAND
		mov edx,wParam
		movzx eax,dx
		shr edx,16
		.if edx==BN_CLICKED
			.if eax==IDOK

			.elseif eax==IDCANCEL
				invoke	SendMessage,hWin,WM_CLOSE,NULL,NULL
			.endif
		.endif
	.elseif	eax==WM_CLOSE
		invoke	EndDialog,hWin,0
	.else
		mov	eax,FALSE
		ret
	.endif
	mov	eax,TRUE
	ret
DlgProc endp

end start
